﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Ozeki.Media.IPCamera;
using Ozeki.Media.IPCamera.Discovery;
using Ozeki.Media.MediaHandlers.Video;

namespace DeviceDiscovery
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void GuiThread(Action action)
        {
            Dispatcher.BeginInvoke(action);
        }

        void GetUsbCameras()
        {
            var usbList = WebCamera.GetDevices();
            foreach (var device in usbList)
                GuiThread(() => DiscoveredDeviceList.Items.Add("[USB] Name: " + device.Name));
        }

        void GetIpCameras()
        {
            IPCameraFactory.DeviceDiscovered += IPCameraFactory_DeviceDiscovered;
            IPCameraFactory.DiscoverDevices();
        }

        private void IPCameraFactory_DeviceDiscovered(object sender, DiscoveryEventArgs e)
        {
            GuiThread(() =>
            {
                DiscoveredDeviceList.Items.Add("[IPCamera] Host: " + e.Device.Host +
                                               " Port: " + e.Device.Port);
            });
        }

        private void DiscoverButton(object sender, RoutedEventArgs e)
        {
            DiscoveredDeviceList.Items.Clear();
            IPCameraFactory.DeviceDiscovered -= IPCameraFactory_DeviceDiscovered;

            GetUsbCameras();
            GetIpCameras();
        }
    }
}
